import processing.sound.*;
SoundFile file;

PFont font;
PFont titleFont;
String begin = "Press b to begin";
String instructions = "Hello, fellow procrastinator!";
String instructionsMainText = "Use your mouse to collect little brains that help you inscrease your focus and avoid instagram that causes distractions! Your goal is to achieve 10 points! If you score lower than zero, you will lose! Press 'b' to play";
String losertext = "lol, try again. Press r to play again, loool";
String winnertext = "lol, you won, so what? This is just a game, do your homework or press r to play again and continue to procrastinate, loool"; //every game I create is a troll :D 

Catcher catcher;

Drop[] drops;
badDrop[] badDrops;

int numDrops;

Timer timer;
int timeInterval;
int activeDrops;

int score;
String s;

int totalDrops = 0;

int screen = 0;
PImage dropbrain;
PImage instalogo;

void setup() {
  size(800, 600);
  textMode(CENTER);
  titleFont = createFont("Courier New Italic", 24);
  font = createFont("Courier New Bold", 18);

  file = new SoundFile(this, "Sound.mp3");

  catcher = new Catcher(30);

  numDrops = 30; //how many drops we want to appear in our project
  drops = new Drop[numDrops];

  for (int i = 0; i<numDrops; i++) {
    drops[i] = new Drop();
  }

  badDrops = new badDrop[numDrops];

  for (int i = 0; i<numDrops; i++) {
    badDrops[i] = new badDrop();
  }

  activeDrops = 0;
  timeInterval = 500;

  timer = new Timer(timeInterval);
  timer.start();

  score = 0;
  s = "Score: " + score;
  dropbrain = loadImage("dropbrain.png");
  instalogo = loadImage("instalogo.png");
}

void draw() {

  switch(screen) {
  case 0:

    background(60, 100, 55);
    fill(255);
    textFont(titleFont);
    text(instructions, width/2, height/4, width/2, height/4);
    textFont(font);
    text(instructionsMainText, width/2, height/2.5, width/2, height/2.5);
    ellipse(width/4, height/2, 200, 200);

    //left eyeball
    ellipse(width/5, height/2, 50, 50);

    //right eyeball
    fill(255);
    ellipse(width/3, height/2, 50, 50);

    //pupil right
    fill(0);
    ellipse(width/5, height/2, 30, 30);

    //pupil left
    fill(0);
    ellipse(width/3, height/2, 30, 30);

    line(width/4.5, height/1.8, width/3.9, height/1.8); //face that looks dissporovingly, this is intentionalll y this bad
    break;


  case 1:

    clearBackground();
    catcher.update();
    catcher.display();

    if (timer.complete() == true) {
      if (activeDrops<numDrops) {
        activeDrops++;
      }
      timer.start();
    }
    //drop stuff
    for (int i = 0; i<activeDrops; i++) {
      drops[i].update();
      drops[i].display();
      //check collisions
      if (intersect(catcher, drops[i]) == true && drops[i].isCaught == false) {
        drops[i].caught(); 
        score++;
      }
    }
    //baddrop stuff
    for (int i = 0; i<activeDrops; i++) {
      badDrops[i].update();
      badDrops[i].display();
      //check collisions
      if (intersect(catcher, badDrops[i]) == true && badDrops[i].isCaught==false) {
        badDrops[i].caught(); 
        score--;
      }
    }
    //update UI
    textSize(12);
    textAlign(LEFT);
    fill(255, 0, 0);
    s = "Focus points: " + score;
    text(s, 10, 20);
    break;


  case 2: //loser
    background(60, 100, 55);
    fill(255);
    textFont(font);
    text(losertext, width/2, height/2, width/2, height/2);
    ellipse(width/4, height/2, 300, 300);

    //right eyeball
    fill(255);
    ellipse(width/3.5, height/2, 50, 50);

    //left eyeball
    fill(255);
    ellipse(width/5, height/2, 50, 50);

    //pupil right
    fill(0);
    ellipse(width/4.9, height/2, 30, 30);

    //pupil left
    fill(0);
    ellipse(width/3.5, height/2, 30, 30);

    line(width/4.5, height/1.5, width/3.9, height/1.5); //face that looks dissporovingly
    break;

  case 3: //winnder
    background(60, 100, 55);
    fill(255);
    textFont(font);
    text(winnertext, width/2, height/2, width/2, height/2);
    ellipse(width/4, height/2, 300, 300);

    ellipse(width/3.5, height/2, 50, 50);

    //left eyeball
    fill(255);
    ellipse(width/5, height/2, 50, 50);

    //pupil right
    fill(0);
    ellipse(width/4.9, height/2, 30, 30);

    //pupil left
    fill(0);
    ellipse(width/3.5, height/2, 30, 30);

    noFill();
    arc(150, 280, 290, 200, 0, HALF_PI);
  }

  if (score < 0) {
    screen = 2;
    file.stop();
  }
  if (score > 10) {
    screen = 3;
    file.stop();
  }
  //println(score);
}

void clearBackground() {
  fill(255);
  rect(0, 0, width, height);
}

boolean intersect(Catcher a, Drop b) {
  float distance = dist(a.x, a.y, b.x, b.y);
  if (distance < a.r+b.r) {
    return true;
  } else {
    return false;
  }
}
boolean intersect(Catcher a, badDrop b) {
  float distance = dist(a.x, a.y, b.x, b.y);
  if (distance < a.r+b.r) {
    return true;
  } else {
    return false;
  }
}

void keyPressed() {
  if  (key == 'r') { //press "r" to restart
    screen = 0;
    file.stop();
    score=0;
  } else if (key == 'b') { // press "b" to begin
    screen = 1;
    file.play();
  }
}
